<template>

	<v-card>
        <v-card-title>
			Regenerate OTP
		</v-card-title>

        <v-card-text>

			<v-form
				ref="form"
				v-model="valid"
				lazy-validation>

				<v-text-field
					v-model="email"
					:rules="emailRules"
					label="E-mail"
					required>
				</v-text-field>

				<v-btn
					:disabled="!valid"
					color="success"
					class="mr-4"
					@click="validate">
					Regenerate OTP
				</v-btn>

				<v-btn
					color="error"
					class="mr-4"
					@click="reset">
					Reset
				</v-btn>

				<alert/>

			</v-form>

        </v-card-text>
        
    </v-card>
  	
</template>

<script>

import alert from '../../components/Alert.vue'
import {mapActions} from 'vuex' 

export default {

	components:{
		alert
	},

	data:function(){
		return{
			valid: true,			
			email: '',
			emailRules: [
				v => !!v || 'E-mail is required',
				v => /.+@.+\..+/.test(v) || 'E-mail must be valid',
			],			  		
		}
	},methods:{
		async submit(){
			try {
				 let response = await axios.post('/api/auth/regenerate-otp', this.regenerateOtp())
				 
				 if(response.status == 200){

					let {response_message, response_code} = response.data
					
					if(response_code=="00"){
						this.show({
							title:'success',
							message: response_message,							
						})
						this.$refs.form.reset()
					}else{
						this.show({
							title:'error',
							message: response_message,							
						})
					}

				 }
			} catch (e) {

				console.log(e.response);

				let {message, errors} = e.response.data
				
				console.log('Error is comming');
				console.log(errors);
				
				this.show({
					title:'error',
					message: response_message,							
					theErrors: errors
				})

			}
		},
		validate:function () {
			let isSuccessfullyValidated = this.$refs.form.validate()
			if(isSuccessfullyValidated){
				console.log(`the input parameter is: ${this.email}`)
				this.submit()
			}else{
				console.log(`the problematic input parameter is : ${this.email}`)

				this.message = 'Your input is not valid!'
				this.snackbar = true
				this.color = 'red'
			}
			
		},
		reset:function () {
			this.$refs.form.reset()
			this.$refs.form.resetValidation()
		},
		regenerateOtp:function(){
			return{
				email:this.email
			}
		},
		...mapActions({
			show:'alert/show'
		})						

	},mounted: function(){
		console.log('Regenarte OTP Screen Mounted')
	}
}
</script>

<style>

</style>